/* Copyright (c) 1992 The Geometry Center; University of Minnesota
   1300 South Second Street;  Minneapolis, MN  55454, USA;
 */

#import <appkit/appkit.h>
#import <math.h>
#import "ProgressView.h"

// Pick a reasonably sized prime number so we don't see patterns.
//  3671 is the  512th prime number.
//  8161 is the 1024th prime number.
// 17863 is the 2048th prime number.
// 38873 is the 4096th prime number.
// 84017 is the 8192th prime number.
#define NUM_POINTS 84017

@interface Scale:Object
{
    id	scaleField;
	id	focusField;
	id	samplesField;
	
	id	inspectorBox;
	id	inspectorContent;
	id	progressBox;
	id	progressContent;
	id	progressView;
	
	float scale;
	float focus;
	int samples;
	
	int outWidth, outHeight;
	int inWidth, inHeight;
	
	NXPoint jitterPoint[NUM_POINTS];
	NXPoint *jit, *jitMin, *jitMax;
	
	NXZone *scratchZone;
	BOOL tablesBuilt;
	BOOL freeStandardBitmap;
}

- init;
- buildTables:(int)seed;
- resetJitterIndex;
- (NXBitmapImageRep *)convertBitmap:(NXBitmapImageRep *)inBitmap;
- (NXBitmapImageRep *)scaleBitmap:(NXBitmapImageRep *)inBitmap;
- filter:(NXBitmapImageRep *)bitmap intoImage:(NXImage *)smartImage;

@end
