/** =======================================================================
*** Net Image Filter -- a netpbm based image filtering service
*** 
*** by Marco Scheurer, Sen:te & Bill Bumgarner, Netsurfer, Inc.
*** 
*** Version 1.1
*** 
*** Copyright 1995, Sente Sarl. All rights reserved. Copyright 1995,
*** Netsurfer, Inc.. All Rights Reserved.
*** 
*** This notice may not be removed from this source code.
*** 
*** This object is included in the MiscKit by permission from the author(s)
*** and its use is governed by the MiscKit license, found in the file
*** "LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
*** for a list of all applicable permissions and restrictions.
*** =======================================================================
**/

#import <objc/Object.h>

@interface NetImageConverter:Object
{
	BOOL isDebug;    /*" If YES, debugging messages will be printed. "*/
	BOOL spewStderr; /*" If YES, subprocess errors will be printed. "*/
	id binaryHash; /*" hash of paths to converter binaries "*/
	id binPaths; /*"list of paths (as NXBundles) where binaries can be found"*/

#ifdef SNOWBALL_IN_HELL /*" INTERNAL "*/
	char *dataBuf; /*" transfer buf used with popen()-- not implemented "*/
#endif /*" INTERNAL "*/
	
	id decoder; /*" instance of SurfImageDecoder "*/
}

/*"
 * Shared Instance
"*/
+ sharedInstance;
+ sharedInstance:(BOOL) debugFlag;

/*"
 * Cache Control
"*/
- printCache;
- resetCache;

/*"
 *  Set / Query
"*/
- setDebug:(BOOL) aFlag;
- (BOOL) isDebug;

- setSpewSTDERR:(BOOL) aFlag;
- (BOOL) spewSTDERR;

/*"
 *  Path Management
"*/
- (const char *) validateConverterPath:(const char *) aPotentialPath;
- (const char *) validateConverter:(const char *) aConverter
                       inDirectory:(const char *) aDirPath;
- (const char *) validateConverter:(const char *) aConverter
                          inBundle:aBundle;
- (const char *) filterPathFromData: (const char *) userData;

/*"
 * Filter Service API
"*/
- anyToTIFF:pasteboard
   userData:(const char *)userData
	  error:(char **)errorMessage;
@end
